#include <P18CXXX.INC>

SWTXD           equ     PORTC           ; Transmit pin port and pin for Bolt system
SWTXDpin        equ     1
TRIS_SWTXD      equ     TRISC           ; Transmit pin tris and pin for Bolt system
SWRXD           equ     PORTC           ; Receive pin port and pin for Bolt system
SWRXDpin        equ     0
TRIS_SWRXD      equ     TRISC           ; Receive pin tris and pin for Bolt system

        EXTERN  DelayRXHalfBitUART
        EXTERN  DelayRXBitUART
        EXTERN  DelayTXBitUART
        EXTERN  uartdata
        EXTERN  BitCount

UARTCODE        CODE
;************************************************************************
;*      Function Name:  ReadUART                                        *
;*      Return Value:   char: received data                             *
;*      Parameters:     void                                            *
;*      Description:    This routine waits for a start bit, and then    *
;*                      reads all 8-bits.                               *
;*																		*
;************************************************************************

ReadUART
        banksel BitCount
        movlw   0x08                    ; Count 8-bits
        movwf   BitCount
        banksel SWRXD
WaitChar
        btfsc   SWRXD,SWRXDpin          ; Detect a start bit (low)
        goto    WaitChar
        call    DelayRXHalfBitUART      ; Delay until middle of start bit
        banksel SWRXD
        btfsc   SWRXD,SWRXDpin          ; If not still low, then go back
        goto    WaitChar                ; and wait for start bit
GetChar                                 ; Loop to get all 8-bits
        call    DelayRXBitUART          ; Delay a full bit for middle of
        banksel SWRXD
        btfss   SWRXD,SWRXDpin          ; Set or clear the carry bit
        bcf             STATUS,C        ; according to the state of the
        btfsc   SWRXD,SWRXDpin          ; RXD I/O pin
        bsf             STATUS,C
        banksel uartdata
        rrcf    uartdata,F              ; Rotate the carry into data
        decfsz  BitCount,F              ; Loop for 8-bits
        goto    GetChar
        call    DelayRXBitUART          ; Delay a full bit time, middle of start bit
        call    DelayRXHalfBitUART      ; Delay half bit for end of start bit
        nop
        banksel uartdata
        movf   uartdata,W,BANKED
        return                          ; Return received character
        GLOBAL  ReadUART
        END
