#include <P18CXXX.INC>

SWTXD           equ     PORTC           ; Transmit pin port and pin for Bolt system
SWTXDpin        equ     1
TRIS_SWTXD      equ     TRISC           ; Transmit pin tris and pin for Bolt system
SWRXD           equ     PORTC           ; Receive pin port and pin for Bolt system
SWRXDpin        equ     0
TRIS_SWRXD      equ     TRISC           ; Receive pin tris and pin for Bolt system

        EXTERN  DelayRXHalfBitUART
        EXTERN  DelayRXBitUART
        EXTERN  DelayTXBitUART
        EXTERN  uartdata
        EXTERN  BitCount

UARTCODE        CODE
;************************************************************************
;*      Function Name:  WriteUART                                       *
;*      Return Value:   void                                            *
;*      Parameters:     data: byte to send out the UART                 *
;*      Description:    This routine sends a byte out the TXD pin.      *
;*																		*
;************************************************************************

WriteUART
        banksel uartdata
        ; Retrieve character from stack.
        movlw   0xFF
        movff   PLUSW1,uartdata
        movlw   0x09                    ; Set bit counter for 9 bits
        movwf   BitCount
        bcf     STATUS,C        		; Send start bit (carry = 0)
        banksel SWTXD
        goto    SendStart
SendBit
        banksel uartdata
        rrcf    uartdata,F              ; Rotate next bit into carry
SendStart
        banksel SWTXD
        btfss   STATUS,C                ; Set or clear TXD pin according
        bcf     SWTXD,SWTXDpin  		; to what is in the carry
        btfsc   STATUS,C
        bsf     SWTXD,SWTXDpin
        call    DelayTXBitUART          ; Delay for 1 bit time
        banksel BitCount
        decfsz  BitCount,F              ; Count only 9 bits
        goto    SendBit
        banksel SWTXD
        bsf     SWTXD,SWTXDpin  		; Stop bit is high
        call    DelayTXBitUART          ; Delay for stop bit
        return
        GLOBAL  WriteUART
        END
